package de.juplo.thymeproxy;

import java.util.Collections;
import org.apache.http.impl.client.CloseableHttpClient;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Bean;
import org.springframework.core.Ordered;
import org.springframework.core.env.Environment;
import org.springframework.web.servlet.handler.SimpleUrlHandlerMapping;


@SpringBootApplication
public class Application
{
  @Bean
  public SimpleUrlHandlerMapping proxiedHandlerMapping(
      ProxyHttpRequestHandler handler
      )
  {
    SimpleUrlHandlerMapping mapping = new SimpleUrlHandlerMapping();
    mapping.setOrder(Ordered.HIGHEST_PRECEDENCE);
    mapping.setUrlMap(Collections.singletonMap("*.html", handler));
	return mapping;
  }

  @Bean
  public ProxyHttpRequestHandler proxiedRequestHandler(
      CloseableHttpClient client,
      Environment env
      )
  {
    ProxyHttpRequestHandler handler = new ProxyHttpRequestHandler();
    handler.setClient(client);
    handler.setOrigin(env.getProperty("thymeproxy.origin"));
    handler.setTtl(30000l);
    return handler;
  }


  public static void main(String[] args)
  {
    SpringApplication.run(Application.class, args);
  }
}